<?php
// wcf imports
if (!defined('NO_IMPORTS')) {
	require_once(WCF_DIR.'lib/system/database/MySQLDatabase.class.php');
	require_once(WCF_DIR.'lib/system/database/DatabaseException.class.php');
}

/**
 * This is the database implementation for MySQL4.1 or higher.
 * 
 * @author	H3llGhost
 * @package	com.h3llghost.wcf
 * @subpackage	system.database
 * @category 	Community Framework
 */
class MySQLDatabaseExtended extends MySQLDatabase {
	protected	$newConnection;
	
	/**
	 * Creates a Dabatase Object.
	 *  
	 * @param	string		$host 		SQL database server host address
	 * @param	string		$user 		SQL database server username
	 * @param	string		$password 	SQL database server password
	 * @param	string		$database 	SQL database server database name
	 * @param	string		$charset	charset for the db connection
	 * @param	boolean		$usePConnect 	indicates whether we use persistent connections to database
	 * @param	boolean		$autoSelect 	indicates whether we select the given database automatically
	 * @param	boolean		$newConnection 	indicates whether we use a new connection
	 */
	public function __construct($host, $user, $password, $database, $charset = 'utf8', $usePConnect = false, $autoSelect = true, $newConnection = false) {
		$this->host 			= $host;
		$this->user 			= $user;
		$this->password 		= $password;
		$this->database			= $database;
		$this->usePConnect		= $usePConnect;
		$this->charset 			= $charset;
		$this->newConnection 	= $newConnection;
		
		$this->connect();

		if ($autoSelect === true) {
			$this->selectDatabase();
		}
		else {
			$this->createDatabase();
			$this->selectDatabase();
		}
	}
	
	/**
	 * Connects to MySQL Server
	 */
	protected function connect() {
		if ($this->usePConnect) {
			$this->linkID = @mysql_pconnect($this->host, $this->user, $this->password, $this->newConnection);
		}
		else {
			$this->linkID = @mysql_connect($this->host, $this->user, $this->password, $this->newConnection);
		}

		if ($this->linkID === false) {
			throw new DatabaseException("Connecting to MySQL server '".$this->host."' failed.", $this);
		}
		
		// set connection character set
		if (!empty($this->charset)) {
			$this->setCharset($this->charset);
		}
	}
	
	public function disconnect() {
		mysql_close($this->linkID);
	}
}
?>